<?php if(!defined('access') or !access) die('This file cannot be directly accessed.'); ?>
<h1>データベースに接続する</h1>
<p>この時点で、必要なファイルをすべてアップロードしたので、Cheveretoがデータを保存する場所を指定する必要があります。 （MySQLデータベース）。</p>
<p>先に、あなたのMySQLデータベースの詳細を提供してください。<a data-modal="simple" data-target="modal-db-info">詳細</a></p>
<div data-modal="modal-db-info" class="hidden">
	<span class="modal-box-title">必要なデータベース情報</span>
	<p>ホスティングプロバイダのウェブサイトパネル（通常はCanPanelまたはPelsk）にアクセスし、必要な情報を入手する必要があります。 あなたがパネルなしでサーバを走らせているなら、SSHを使ってこれを得ることができるはずです。</p>
	<p>基本的には、データベース（これはデータベース名）を作成し、このデータベースの権限をデータベースユーザーに割り当てる必要があります。</p>
	<p>Cheveretoはデータベースのユーザー資格情報を使用してデータベースホストに接続するため、ユーザーはターゲットデータベース名にアクセスする必要があります。</p>
</div>

<p>ここにインストールする際には、問題を確認する必要があります。責任を負いません。<a data-modal="simple" data-target="modal-db-info1"> ApacheおよびNginx環境使用方法</a></p>
<div data-modal="modal-db-info1" class="hidden">
	<span class="modal-box-title">必要なデータベース情報</span>
	<p>1.Apache環境構築サポートPHP7.0以上。</p>
	<br>	
	<p>2.Nginxは擬似静的ルールを使用する必要があります。</p>

<p># Chevereto Nginx rewrite rules</p>
<p># Make sure to place these inside your server{} block</p>
<p></p>
<p># Disable access to .ht* files</p>
<p>location ~ /\.ht {</p>
<p>	deny all;</p>
<p>}</p>
<p></p>
<p># Disable access to sensitive files in app path</p>
<p>location ~ /(app|content|lib)/.*\.(po|php|lock|sql)$ {</p>
<p>   deny all;</p>
<p>}</p>
<p></p>
<p># Disable log on not found images + image replacement</p>
<p>location ~* (jpe?g|png|gif) {</p>
<p>	log_not_found off;</p>
<p>	error_page 404 /content/images/system/default/404.gif;</p>
<p>}</p>
<p></p>
<p># Enable CORS header (needed for CDN)</p>
<p>location ~* \.(ttf|ttc|otf|eot|woff|woff2|css|js)$ {</p>
<p>	add_header Access-Control-Allow-Origin "*";</p>
<p>}</p>
<p></p>
<p># Force serve upload path as static content (match your upload folder if needed)</p>
<p>location /images {}</p>
<p></p>
<p># Route dynamic request to index.php</p>
<p>location / {</p>
<p>	try_files $uri $uri/ /index.php?$query_string;</p>
<p>}</p>
</div>

<?php if($error) { ?>
<p class="highlight padding-10"><?php echo $error_message; ?></p>
<?php } ?>
<form method="post" class="c9">
	<div class="input-label">
		<label for="db_host">データベースホスト</label>
		<input type="text" name="db_host" id="db_host" class="text-input" value="<?php echo isset($_POST['db_host']) ? $_POST['db_host'] : 'localhost'; ?>" placeholder="通常はlocalhost" title="データベースサーバーホスト（デフォルト：localhost）" rel="tooltip" data-tipTip="right" required>
	</div>
	<div class="input-label">
		<label for="db_name">データベース名</label>
		<input type="text" name="db_name" id="db_name" class="text-input" value="<?php echo isset($_POST['db_name']) ? $_POST['db_name'] : ''; ?>" placeholder="データベース名" title="Cheveretoをインストールするデータベースの名前" rel="tooltip" data-tipTip="right" required>
	</div>
	<div class="input-label">
		<label for="db_user">データベースのユーザー名</label>
		<input type="text" name="db_user" id="db_user" class="text-input" value="<?php echo isset($_POST['db_user']) ? $_POST['db_user'] : ''; ?>" placeholder="データベースユーザー" title="上記のデータベースにアクセスしているユーザー" rel="tooltip" data-tipTip="right" required>
	</div>
	<div class="input-label">
		<label for="db_pass">データベースユーザーのパスワード</label>
		<input type="text" name="db_pass" id="db_pass" class="text-input" value="<?php echo isset($_POST['db_pass']) ? $_POST['db_pass'] : ''; ?>" placeholder="データベースユーザーのパスワード" title="上記のユーザーのパスワード" rel="tooltip" data-tipTip="right">
	</div>
	<div class="input-label">
		<label for="db_table_prefix">データベーステーブル接頭辞</label>
		<input type="text" name="db_table_prefix" id="db_table_prefix" class="text-input" value="<?php echo isset($_POST['db_table_prefix']) ? $_POST['db_table_prefix'] : 'chv_'; ?>" placeholder="通常は chv_" title="データベーステーブルの接頭辞。 必要ない場合は chv_ を使用してください" rel="tooltip" data-tipTip="right">
	</div>
	<div class="btn-container margin-bottom-0">
		<button class="btn btn-input default" type="submit">続ける</button>
	</div>
</form>