<?php if(!defined('access') or !access) die('This file cannot be directly accessed.'); ?>
<h1>インストール準備完了</h1>
<p>システムがデータベースに接続されている。 <code>app/settings.php</code> このファイルには、この接続情報が含まれています。 データベース接続情報を変更しない限り、このファイルの内容を変更しないでください。</p>
<p>このプロセスを送信するとCheveretoデータベーステーブルがインストールされ、後で変更できるいくつかのデフォルト設定が設定されます。</p>
<p>インストールを続行するには、このフォームに最初の管理アカウントと使用するデフォルトのメール設定の詳細を入力してください。このアカウントと設定を後で編集できることを心配しないでください。</p>
<?php if($error) { ?>
<p class="highlight padding-10"><?php echo $error_message; ?></p>
<?php } ?>
<form method="post">
	<div class="c9">
        <div class="input-label">
            <label for="username">管理者のユーザー名</label>
            <input type="text" name="username" id="username" class="text-input" value="<?php echo isset($_POST['username']) ? $_POST['username'] : NULL; ?>" placeholder="管理者のユーザー名" rel="tooltip" data-tipTip="right" pattern="<?php echo CHV\getSetting('username_pattern'); ?>" rel="tooltip" title='<?php echo strtr('%i または %f テキスト<br>レター, 番号 和 "_"', ['%i' => CHV\getSetting('username_min_length'), '%f' => CHV\getSetting('username_max_length')]); ?>' maxlength="<?php echo CHV\getSetting('username_max_length'); ?>" required>
            <span class="input-warning red-warning"><?php echo $input_errors['username']; ?></span>
        </div>
        <div class="input-label">
            <label for="email">メールを管理する</label>
            <input type="email" name="email" id="email" class="text-input" value="<?php echo isset($_POST['email']) ? $_POST['email'] : ''; ?>" placeholder="メールを管理する" title="管理アカウントの有効なメールアドレス" rel="tooltip" data-tipTip="right" required>
            <span class="input-warning red-warning"><?php echo $input_errors['email']; ?></span>
        </div>
        <div class="input-label input-password">
            <label for="password">管理者パスワード</label>
            <input type="password" name="password" id="password" class="text-input" value="<?php echo isset($_POST['password']) ? $_POST['password'] : ''; ?>" placeholder="管理者パスワード" title="ログインパスワード" pattern="<?php echo CHV\getSetting('user_password_pattern'); ?>" rel="tooltip" data-tipTip="right" required>
            <div class="input-password-strength"><span style="width: 0%" data-content="password-meter-bar"></span></div>
            <span class="input-warning red-warning" data-text="password-meter-message"><?php echo $input_errors['password']; ?></span>
        </div>
    </div>
    <hr class="line-separator"></hr>
    <div class="c9">
        <div class="input-label">
            <label for="email_from_email"><?php _se('メールアドレスから'); ?></label>
            <input type="email" name="email_from_email" id="email_from_email" class="text-input" value="<?php echo isset($_POST['email_from_email']) ? $_POST['email_from_email'] : ''; ?>" placeholder="no-reply@example.com" title="<?php _se('ユーザーの送信者の電子メールに電子メールを送信します。'); ?>" rel="tooltip" data-tipTip="right" required>
            <span class="input-warning red-warning"><?php echo $input_errors['email_from_email']; ?></span>
        </div>
        <div class="input-label">
            <label for="email_incoming_email"><?php _se('メールアドレスを入力してください'); ?></label>
            <input type="email" name="email_incoming_email" id="email_incoming_email" class="text-input" value="<?php echo isset($_POST['email_incoming_email']) ? $_POST['email_incoming_email'] : NULL; ?>" placeholder="inbox@example.com" title="<?php _se('システム通知のフォームと受信者に連絡してください。'); ?>" rel="tooltip" data-tipTip="right" required>
            <span class="input-warning red-warning"><?php echo $input_errors['email_incoming_email']; ?></span>
        </div>
    </div>
	<hr class="line-separator"></hr>
    <div class="c9">
		<div class="input-label">
			<label for="website_mode"><?php _se('ウェブサイトモード'); ?></label>
			<div class="c5 phablet-c1"><select type="text" name="website_mode" id="website_mode" class="text-input" data-combo="website-mode-combo" title="<?php _se('いつでもウェブサイトモードを切り替えることができます。'); ?>" rel="tooltip" data-tipTip="right">
				<?php
					echo CHV\Render\get_select_options_html(['community' => _s('コミュニティ'), 'personal' => _s('個人')], isset($_POST['website_mode']) ? $_POST['website_mode'] : NULL);
				?>
			</select></div>
			<div class="input-below input-warning red-warning"><?php echo $input_errors['website_mode']; ?></div>
		</div>
	</div>
	<?php
		if($is_2X) {
	?>
    <hr class="line-separator"></hr>
    <div class="c9">
        <div class="input-label">
            <label for="crypt_salt">__CHV_CRYPT_SALT__</label>
            <input type="crypt_salt" name="crypt_salt" id="crypt_salt" class="text-input" value="<?php echo isset($_POST['crypt_salt']) ? $_POST['crypt_salt'] : ''; ?>" placeholder="Example: changeme" title="As defined in includes/definitions.php" rel="tooltip" data-tipTip="right" required>
            <span class="input-below highlight">Value from define("__CHV_CRYPT_SALT__", "changeme");</span>
            <span class="input-warning red-warning"><?php echo $input_errors['crypt_salt']; ?></span>
        </div>
    </div>
	<?php
		}
	?>
    <span class="line-separator"></span>
	<div class="btn-container margin-bottom-0">
		<button class="btn btn-input default" type="submit">Cheveretoをインストール</button>
	</div>
</form>